File Init.c

// SCHEDA PICDEM2 PLUS
// Definizione della MAPPA DELLE PORTE, 
// con PIC18F242, 28 piedini, collegato attraverso il PORTB 0-3 al Display
// e di tutte le routine di INIZIALIZZAZIONE dell'Hardware...

/* direzione delle porte I/O -------------------------------------------*/

#define START_PORTA       0b00000000  // Valore iniziale USCITE PortA
#define DIR_PORT_A        0b11110001  //
                       /*   |||||||+---- PA(0) = Potenziometro
                            ||||||+----- PA(1) = LCD - Enable
                            |||||+------ PA(2) = LCD - R/W
                            ||||+------- PA(3) = LCD - RS
                            |||+-------- PA(4) = Switch S2 (negato)
                            ||+--------- PA(5) = N.c.
                            |+---------- PA(6) = 
                            +----------- PA(7) = 
                       */            
#define START_PORTB       0b00000000  // Valore iniziale USCITE PortB
#define DIR_PORT_B        0b11110000  //
                       /*   |||||||+---- PB(0) = LCD - Dato || Led
                            ||||||+----- PB(1) = LCD - Dato || Led
                            |||||+------ PB(2) = LCD - Dato || Led
                            ||||+------- PB(3) = LCD - Dato || Led
                            |||+-------- PB(4) = nc
                            ||+--------- PB(5) = nc
                            |+---------- PB(6) = ICD2
                            +----------- PB(7) = ICD2
                       */            
#define START_PORTC       0b00000000  // Valore iniziale USCITE PortC 
#define DIR_PORT_C        0b10111011   
                       /*   |||||||+---- PC(0) = nc
                            ||||||+----- PC(1) = nc
                            |||||+------ PC(2) = BUZZER
                            ||||+------- PC(3) = I2C-SCL
                            |||+-------- PC(4) = I2C-SDA
                            ||+--------- PC(5) = nc
                            |+---------- PC(6) = TX Seriale RS232
                            +----------- PC(7) = RX Seriale RS232
                       */            

// TASTI
#define S2                   PORTAbits.RA4
#define S3                   (TRISBbits.RB0=1, PORTAbits.RB0)

void InitPort(void)
  {
  // Inizializzazione PORTE del PIC
  PORTA = START_PORTA;
  TRISA = DIR_PORT_A;       
  ADCON1 = 0b00001110;	// Metto TUTTI gli ingressi di A in digitale
                        // tranne il primo, a cui  attaccato il POT
  PORTB = START_PORTB;
  TRISB = DIR_PORT_B;
  PORTC = START_PORTC;
  TRISC = DIR_PORT_C;
  }




File main.c

// ----------------------------------------------------------------
// --------  Funzionamento BASE della SCHEDA PIC-DEM2PLUS ---------
// --------         seminario del 6-3-2004 Cesena         ---------
// ----------------------------------------------------------------


#include <p18f452.h>
#include "Init.h"

// Variabili globali -------------------------------------------------------

 char cont = 0;   // Contatore 
 int  flag = 0;   // flag per il debounce del tasto.


// ----------------------------------------------------------------
//
//                 M  A  I  N            F  L  O  W 
//
// ----------------------------------------------------------------

void main(void)
  { 
  InitPort();      // Inizializzazione PORTE del PIC
       
  while (1)        // Ciclo "main" infinito
    {

/*
    if (!S2)           // se il tasto S2  premuto (il SEGNALE va BASSO,
       {               //                           quindi c' la negazione!)
       cont++;         // incremento il Conteggio
       PORTB = cont;   // e lo sputo fuori nel PORTB (sui LED!)
       }
                       // BUG:  se tengo premuto conta in avanti fisso.
*/    

                       // Per risolvere introduco la variabile "flag"
                       // che costituisce un debounce Software.
                       
    if (!S2) flag = flag+1;   // se il tasto S2  premuto incremento "flag"
       else  flag = 0;        // altrimenti lo AZZERO
    
    if (flag == 5)            // flag vale 5 SOLO se per cinque passaggi
       {                      // ho letto S2 premuto, senza rimbalzi
       cont++;                // Incremento il  Conteggio
       PORTB = cont;          // e lo metto fuori nel PORTB (LED)
       }
  }
